using System;
using System.Diagnostics;
using System.ServiceProcess;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace WindowsService
{
	public class RemotingService : System.ServiceProcess.ServiceBase
	{
		private static EventLog evt = new EventLog("Application");
		public static String serviceName = ".NET Remoting";

		/// <summary>
		/// Constructor
		/// </summary>
		public RemotingService()
		{
			this.ServiceName = serviceName;
		}

		/// <summary>
		/// Entry Point
		/// </summary>
		static void Main()
		{
			evt.Source = serviceName;
			evt.WriteEntry("Inicializando Servicio de Componentes Remotos");
			System.ServiceProcess.ServiceBase.Run(new RemotingService());
		}


		/// <summary>
		/// Inicio del Servicio
		/// </summary>
		/// <param name="args"></param>
		protected override void OnStart(string[] args)
		{
			evt.WriteEntry(".NET Componentes Remotos Iniciado");
			//Registrar las fachadas que estarian dando servicio remoto
			String filename = @"server.exe.config";
			RemotingConfiguration.Configure(filename);
		}
 
		/// <summary>
		/// Parar el Servicio
		/// </summary>
		protected override void OnStop()
		{
			evt.WriteEntry(".NET Componentes Remotos Detenido");
			foreach (System.Runtime.Remoting.Channels.IChannel  canal in ChannelServices.RegisteredChannels)
			{
				ChannelServices.UnregisterChannel(canal); 
			}
		}
	}
}
